
package com.rjconsultores.ventaboletos.service.impl;

import java.util.Calendar;
import java.util.Collection;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.rjconsultores.ventaboletos.dao.ConexionConfDAO;
import com.rjconsultores.ventaboletos.entidad.ConexionConf;
import com.rjconsultores.ventaboletos.entidad.ConexionCtrl;
import com.rjconsultores.ventaboletos.service.ConexionConfService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;

@Service("conexionConfService")
public class ConexionConfServiceImpl implements ConexionConfService {
	@Autowired
	private ConexionConfDAO conexionConfDAO;

	public List<ConexionConf> obtenerTodos() {
		return conexionConfDAO.obtenerTodos();
	}

	public ConexionConf obtenerID(Long id) {
		return conexionConfDAO.obtenerID(id);
	}

	@Transactional
	public ConexionConf suscribir(ConexionConf entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.TRUE);

		return conexionConfDAO.suscribir(entidad);
	}

	@Transactional
	public ConexionConf actualizacion(ConexionConf entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.TRUE);

		return conexionConfDAO.actualizacion(entidad);
	}

	@Transactional
	public void borrar(ConexionConf entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.FALSE);

		conexionConfDAO.actualizacion(entidad);
	}

	@Override
	public ConexionConf buscar(Long conexionCtrlId, Integer numgrupo) {
		return conexionConfDAO.buscar(conexionCtrlId, numgrupo);
	}

	@Override
	public List<ConexionConf> buscarPorConexionCtrl(ConexionCtrl entidad) {
		return conexionConfDAO.buscarPorConexionCtrl(entidad);
	}

	@Override
	@Transactional
	public void suscribirTodos(Collection<ConexionConf> conexionesConf) {
		conexionConfDAO.suscribirTodos(conexionesConf);
	}
}
